diff -Naur linux-2.4.2-orig/drivers/usb/ov511.c linux/drivers/usb/ov511.c
--- linux-2.4.2-orig/drivers/usb/ov511.c	Fri Mar  2 03:21:10 2001
+++ linux/drivers/usb/ov511.c	Tue Mar 27 22:24:30 2001
@@ -899,12 +1378,92 @@
 	p->depth = ov511->frame[0].depth;
 	p->palette = ov511->frame[0].format;
 
-	if (ov511_restart(dev) < 0)
+	if (ov511_restart(ov511) < 0)
 		return -EIO;
 
 	return 0;
 }
 
+/* Turns on or off the LED. Only has an effect with OV511+/OV518+ */
+static inline void 
+ov511_led_control(struct usb_ov511 *ov511, int enable) {
+	PDEBUG(4, " (%s)", enable ? "turn on" : "turn off");
+
+	if (ov511->bridge == BRG_OV511PLUS)
+		ov511_reg_write(ov511->dev, OV511_REG_SYSTEM_LED_CTL, 
+			        enable ? 1 : 0);
+	else if (ov511->bridge == BRG_OV518PLUS)
+		ov511_reg_write_mask(ov511->dev, OV518_REG_GPIO_OUT, 
+				     enable ? 0x02 : 0x00, 0x02);
+	return;
+}
+
+/* Matches the sensor's internal frame rate to the lighting frequency.
+ * Valid frequencies are:
+ *	50 - 50Hz, for European and Asian lighting
+ *	60 - 60Hz, for American lighting
+ *
+ * Tested with: OV7610, OV7620, OV7620AE, OV6620
+ * Returns: 0 for success
+ */
+static inline int
+ov51x_set_light_freq(struct usb_ov511 *ov511, int freq) {
+	int sixty;
+
+	PDEBUG(4, "%d Hz", freq);
+
+	if (freq == 60)
+		sixty = 1;
+	else if (freq == 50)
+		sixty = 0;
+	else {
+		err("Invalid light freq (%d Hz)", freq);
+		return -EINVAL;
+	}
+	
+	switch (ov511->sensor) {
+	case SEN_OV7610:
+		ov511_i2c_write_mask(ov511->dev, 0x2a, sixty?0x00:0x80, 0x80);
+		ov511_i2c_write(ov511->dev, 0x2b, sixty?0x00:0xac);
+		ov511_i2c_write_mask(ov511->dev, 0x13, 0x10, 0x10);
+		ov511_i2c_write_mask(ov511->dev, 0x13, 0x00, 0x10);
+		break;
+	case SEN_OV7620:
+	case SEN_OV7620AE:
+	case SEN_OV8600:
+		ov511_i2c_write_mask(ov511->dev, 0x2a, sixty?0x00:0x80, 0x80);
+		ov511_i2c_write(ov511->dev, 0x2b, sixty?0x00:0xac);
+		ov511_i2c_write_mask(ov511->dev, 0x76, 0x01, 0x01);
+		break;		
+	case SEN_OV6620:
+	case SEN_OV6630:
+		ov511_i2c_write(ov511->dev, 0x2b, sixty?0xa8:0x28);
+		ov511_i2c_write(ov511->dev, 0x2a, sixty?0x84:0xa4);
+		break;
+	default:
+		err("Sensor not supported for set_light_freq");
+		return -EINVAL;
+	}
+
+	return 0;
+}
+
+/* If enable is true, turn on the sensor's banding filter, otherwise turn it off. This
+ * filter tries to reduce the pattern of horizontal light/dark bands caused by some
+ * (usually fluorescent) lighting. The light frequency must be set either before or
+ * after enabling it with ov51x_set_light_freq().
+ *
+ * Tested with: OV7610, OV7620AE, OV6620. Ruins exposure with OV7620.
+ * Returns: 0 for success
+ */
+static inline int
+ov51x_set_banding_filter(struct usb_ov511 *ov511, int enable)
+{	
+	PDEBUG(4, " (%s)", enable ? "turn on" : "turn off");
+
+	return (ov511_i2c_write_mask(ov511->dev, 0x2d, enable?0x04:0x00, 0x04));
+}
+
 /* Returns number of bits per pixel (regardless of where they are located; planar or
  * not), or zero for unsupported format.
  */
@@ -918,12 +1477,13 @@
 	case VIDEO_PALETTE_YUYV:    return 16;
 	case VIDEO_PALETTE_YUV420:  return 24;
 	case VIDEO_PALETTE_YUV422P: return 24; /* Planar */
+	case VIDEO_PALETTE_YUV420P: return 24; /* Planar */
 	default:		    return 0;  /* Invalid format */
 	}
 }
 
 /* LNCNT values fixed by Lawrence Glaister <lg@jfm.bc.ca> */
-static struct mode_list mlist[] = {
+static struct mode_list_511 mlist511[] = {
 	/* W    H   C  PXCNT LNCNT PXDIV LNDIV M420  COMA  COML */
 	{ 640, 480, 0, 0x4f, 0x3b, 0x00, 0x00, 0x03, 0x24, 0x9e },
 	{ 640, 480, 1, 0x4f, 0x3b, 0x00, 0x00, 0x03, 0x24, 0x9e },
@@ -935,8 +1495,8 @@
 	{ 384, 288, 1, 0x2f, 0x25, 0x00, 0x00, 0x03, 0x04, 0x1e },
 	{ 448, 336, 0, 0x37, 0x29, 0x00, 0x00, 0x03, 0x04, 0x1e },
 	{ 448, 336, 1, 0x37, 0x29, 0x00, 0x00, 0x03, 0x04, 0x1e },
-	{ 176, 144, 0, 0x15, 0x12, 0x00, 0x00, 0x03, 0x04, 0x1e },
-	{ 176, 144, 1, 0x15, 0x12, 0x00, 0x00, 0x03, 0x04, 0x1e },
+	{ 176, 144, 0, 0x13, 0x13, 0x00, 0x00, 0x03, 0x04, 0x1e },
+	{ 176, 144, 1, 0x13, 0x13, 0x00, 0x00, 0x03, 0x04, 0x1e },
 	{ 160, 120, 0, 0x13, 0x0e, 0x00, 0x00, 0x03, 0x04, 0x1e },
 	{ 160, 120, 1, 0x13, 0x0e, 0x00, 0x00, 0x03, 0x04, 0x1e },
 	{ 0, 0 }
@@ -949,12 +1509,12 @@
 	int i;
 	struct usb_device *dev = ov511->dev;
 	int hwsbase, hwebase, vwsbase, vwebase, hwsize, vwsize; 
-	int hwscale = 0, vwscale = 0;
+	int hoffset, voffset, hwscale = 0, vwscale = 0;
 
 	PDEBUG(3, "width:%d, height:%d, mode:%d, sub:%d",
 	       width, height, mode, sub_flag);
 
-	if (ov511_stop(ov511->dev) < 0)
+	if (ov511_stop(ov511) < 0)
 		return -EIO;
 
 	/* Dumppix only works with RGB24 */
@@ -967,10 +1527,10 @@
 		ov511_reg_write(dev, 0x16, 0x00);
 		if (ov511->sensor == SEN_OV7610
 		    || ov511->sensor == SEN_OV7620AE) {
-			/* these aren't valid on the OV6620/OV7620 */
+			/* these aren't valid on the OV6620/OV7620/6630? */
 			ov511_i2c_write(dev, 0x0e, 0x44);
 		}
-		ov511_i2c_write(dev, 0x13, autoadjust ? 0x21 : 0x20);
+		ov511_i2c_write_mask(dev, 0x13, autoadjust ? 0x21 : 0x20, 0x21);
 
 		/* For snapshot */
 		ov511_reg_write(dev, 0x1e, 0x00);
@@ -979,17 +1539,18 @@
 		ov511_reg_write(dev, 0x16, 0x01);
 		if (ov511->sensor == SEN_OV7610
 		    || ov511->sensor == SEN_OV7620AE) {
-			/* not valid on the OV6620/OV7620 */
+			/* not valid on the OV6620/OV7620/6630? */
 			ov511_i2c_write(dev, 0x0e, 0x04);
 		}
-		ov511_i2c_write(dev, 0x13, autoadjust ? 0x01 : 0x00);
+		ov511_i2c_write_mask(dev, 0x13, autoadjust ? 0x01 : 0x00, 0x21);
 
 		/* For snapshot */
 		ov511_reg_write(dev, 0x1e, 0x01);
 		ov511_reg_write(dev, 0x1f, 0x03);
 	}
 
-	/* The different sensor ICs handle setting up of window differently */
+	/* The different sensor ICs handle setting up of window differently.
+	 * IF YOU SET IT WRONG, YOU WILL GET ALL ZERO ISOC DATA FROM OV511!!! */
 	switch (ov511->sensor) {
 	case SEN_OV7610:
 	case SEN_OV7620AE:
@@ -998,6 +1559,7 @@
 		vwsbase = vwebase = 0x05;
 		break;
 	case SEN_OV6620:
+	case SEN_OV6630:	// FIXME: Is this right?
 		hwsbase = 0x38;
 		hwebase = 0x3a;
 		vwsbase = 0x05;
@@ -1042,6 +1604,10 @@
 		}	
 	}
 
+	/* Center the window */
+	hoffset = ((hwsize - width) / 2) >> hwscale;
+	voffset = ((vwsize - height) / 2) >> vwscale;
+
 	/* FIXME! - This needs to be changed to support 160x120 and 6620!!! */
 	if (sub_flag) {
 		ov511_i2c_write(dev, 0x17, hwsbase+(ov511->subx>>hwscale));
@@ -1049,102 +1615,459 @@
 		ov511_i2c_write(dev, 0x19, vwsbase+(ov511->suby>>vwscale));
 		ov511_i2c_write(dev, 0x1a, vwebase+((ov511->suby+ov511->subh)>>vwscale));
 	} else {
-		ov511_i2c_write(dev, 0x17, hwsbase);
-		ov511_i2c_write(dev, 0x18, hwebase + (hwsize>>hwscale));
-		ov511_i2c_write(dev, 0x19, vwsbase);
-		ov511_i2c_write(dev, 0x1a, vwebase + (vwsize>>vwscale));
+		ov511_i2c_write(dev, 0x17, hwsbase + hoffset);
+		ov511_i2c_write(dev, 0x18, hwebase + hoffset + (hwsize>>hwscale));
+		ov511_i2c_write(dev, 0x19, vwsbase + voffset);
+		ov511_i2c_write(dev, 0x1a, vwebase + voffset + (vwsize>>vwscale));
 	}
 
-	for (i = 0; mlist[i].width; i++) {
+	for (i = 0; mlist511[i].width; i++) {
 		int lncnt, pxcnt, clock;
 
-		if (width != mlist[i].width || height != mlist[i].height)
+		if (width != mlist511[i].width || height != mlist511[i].height)
 			continue;
 
-		if (!mlist[i].color && mode != VIDEO_PALETTE_GREY)
+		if (!mlist511[i].color && mode != VIDEO_PALETTE_GREY)
 			continue;
 
 		/* Here I'm assuming that snapshot size == image size.
 		 * I hope that's always true. --claudio
 		 */
-		pxcnt = sub_flag ? (ov511->subw >> 3) - 1 : mlist[i].pxcnt;
-		lncnt = sub_flag ? (ov511->subh >> 3) - 1 : mlist[i].lncnt;
+		pxcnt = sub_flag ? (ov511->subw >> 3) - 1 : mlist511[i].pxcnt;
+		lncnt = sub_flag ? (ov511->subh >> 3) - 1 : mlist511[i].lncnt;
 
 		ov511_reg_write(dev, 0x12, pxcnt);
 		ov511_reg_write(dev, 0x13, lncnt);
-		ov511_reg_write(dev, 0x14, mlist[i].pxdv);
-		ov511_reg_write(dev, 0x15, mlist[i].lndv);
-		ov511_reg_write(dev, 0x18, mlist[i].m420);
+		ov511_reg_write(dev, 0x14, mlist511[i].pxdv);
+		ov511_reg_write(dev, 0x15, mlist511[i].lndv);
+		ov511_reg_write(dev, 0x18, mlist511[i].m420);
 
 		/* Snapshot additions */
 		ov511_reg_write(dev, 0x1a, pxcnt);
 		ov511_reg_write(dev, 0x1b, lncnt);
-                ov511_reg_write(dev, 0x1c, mlist[i].pxdv);
-                ov511_reg_write(dev, 0x1d, mlist[i].lndv);
+                ov511_reg_write(dev, 0x1c, mlist511[i].pxdv);
+                ov511_reg_write(dev, 0x1d, mlist511[i].lndv);
+
+		/* The OV6620 needs special handling. This prevents the 
+		 * severe banding that normally occurs */
+		if (ov511->sensor == SEN_OV6620)
+		{
+			/* Clock down */
+			ov511_i2c_write(dev, 0x2a, 0x04);
+			ov511_i2c_write(dev, 0x11, 0x03);
+			ov511_i2c_write(dev, 0x2a, 0x84);
+			/* This next setting is critical. It seems to improve
+			 * the gain or the contrast. The "reserved" bits seem
+			 * to have some effect in this case. */
+			ov511_i2c_write(dev, 0x2d, 0x85);
 
-		/* Calculate and set the clock divisor */
-		clock = ((sub_flag ? ov511->subw * ov511->subh : width * height)
-			* (mlist[i].color ? 3 : 2) / 2) / 66000;
+		}
+		else
+		{
+			/* Calculate and set the clock divisor */
+			clock = ((sub_flag ? ov511->subw * ov511->subh : width * height)
+			* (mlist511[i].color ? 3 : 2) / 2) / 66000;
 #if 0
-		clock *= cams;
+			clock *= cams;
 #endif
-		ov511_i2c_write(dev, 0x11, clock);
+			ov511_i2c_write(dev, 0x11, clock);
+		}
 
 		/* We only have code to convert GBR -> RGB24 */
 		if ((mode == VIDEO_PALETTE_RGB24) && sensor_gbr)
-			ov511_i2c_write(dev, 0x12, mlist[i].common_A | (testpat?0x0a:0x08));
+			ov511_i2c_write(dev, 0x12, mlist511[i].common_A | (testpat?0x0a:0x08));
 		else
-			ov511_i2c_write(dev, 0x12, mlist[i].common_A | (testpat?0x02:0x00));
+			ov511_i2c_write(dev, 0x12, mlist511[i].common_A | (testpat?0x02:0x00));
+
+		/* Enable/Disable AGC */
+		if (ov511_i2c_write_mask(dev, 0x12, autoadjust ? 0x20 : 0x00, 0x20) < 0)
+			return -1;
 
-		/* 7620/6620 don't have register 0x35, so play it safe */
+		/* 7620/6620/6630? don't have register 0x35, so play it safe */
 		if (ov511->sensor == SEN_OV7610 ||
 		    ov511->sensor == SEN_OV7620AE)
-			ov511_i2c_write(dev, 0x35, mlist[i].common_L);
+			ov511_i2c_write(dev, 0x35, mlist511[i].common_L);
 
 		break;
 	}
 
+	if (lightfreq)
+		if (ov51x_set_light_freq(ov511, lightfreq))
+			return -1;
+
+	if (ov51x_set_banding_filter(ov511, bandingfilter))
+			return -1;
+
 	if (compress) {
-		ov511_reg_write(dev, 0x78, 0x03); // Turn on Y compression
-		ov511_reg_write(dev, 0x79, 0x00); // Disable LUTs
+		ov511_reg_write(dev, 0x78, 0x07); // Turn on Y and UV compression
+		ov511_reg_write(dev, 0x79, 0x03); // Enable LUTs
+		ov511_reset(ov511, OV511_RESET_OMNICE);
 	}
 
-	if (ov511_restart(ov511->dev) < 0)
+	if (ov511_restart(ov511) < 0)
 		return -EIO;
 
-	if (mlist[i].width == 0) {
+	if (mlist511[i].width == 0) {
 		err("Unknown mode (%d, %d): %d", width, height, mode);
 		return -EINVAL;
 	}
 
 #ifdef OV511_DEBUG
-	if (debug >= 5)
+	if (dump_sensor)
 		ov511_dump_i2c_regs(dev);
 #endif
 
 	return 0;
 }
 
-/**********************************************************************
- *
- * Color correction functions
- *
- **********************************************************************/
+static struct mode_list_518 mlist518[] = {
+	/* W    H   reg28 reg29 reg2a reg2c reg2e reg24 reg25 */
+	{ 352, 288, 0x80, 0x16, 0x48, 0x00, 0x00, 0x9f, 0x90 },
+	{ 320, 240, 0x80, 0x14, 0x3c, 0x10, 0x18, 0x9f, 0x90 },
+	{ 176, 144, 0x85, 0x0b, 0x24, 0x00, 0x00, 0xff, 0xf0 },
+	{ 160, 120, 0x85, 0x0a, 0x1e, 0x08, 0x0c, 0xff, 0xf0 },
+	{ 0, 0 }
+};
 
-/*
- * Turn a YUV4:2:0 block into an RGB block
- *
- * Video4Linux seems to use the blue, green, red channel
- * order convention-- rgb[0] is blue, rgb[1] is green, rgb[2] is red.
- *
- * Color space conversion coefficients taken from the excellent
- * http://www.inforamp.net/~poynton/ColorFAQ.html
- * In his terminology, this is a CCIR 601.1 YCbCr -> RGB.
- * Y values are given for all 4 pixels, but the U (Pb)
- * and V (Pr) are assumed constant over the 2x2 block.
- *
- * To avoid floating point arithmetic, the color conversion
- * coefficients are scaled into 16.16 fixed-point integers.
+/* OV518 needs a completely different approach, until we can figure out what
+ * the individual registers do. Many register ops are commented out until we
+ * can find out if they are still valid. Also, only 15 FPS is supported now.
+ */
+static int
+ov518_mode_init_regs(struct usb_ov511 *ov511,
+		     int width, int height, int mode, int sub_flag)
+{
+	int i;
+	struct usb_device *dev = ov511->dev;
+	int hwsbase, hwebase, vwsbase, vwebase, hwsize, vwsize; 
+	int hoffset, voffset, hwscale = 0, vwscale = 0;
+	unsigned char b[3]; /* Multiple-value reg buffer */
+
+	PDEBUG(3, "width:%d, height:%d, mode:%d, sub:%d",
+	       width, height, mode, sub_flag);
+
+	if (ov511_stop(ov511) < 0)
+		return -EIO;
+
+	/* Dumppix only works with RGB24 */
+	if (dumppix && (mode != VIDEO_PALETTE_RGB24)) {
+		err("dumppix only supported with RGB 24");
+		return -EINVAL;
+	}
+
+	/* I don't know how to set YUV400 mode on OV518 yet */
+	if (mode == VIDEO_PALETTE_GREY) {
+//		ov511_reg_write(dev, 0x16, 0x00);
+		if (ov511->sensor == SEN_OV7610
+		    || ov511->sensor == SEN_OV7620AE) {
+			/* these aren't valid on the OV6620/OV7620/6630? */
+			ov511_i2c_write(dev, 0x0e, 0x44);
+		}
+		ov511_i2c_write_mask(dev, 0x13, autoadjust ? 0x21 : 0x20, 0x21);
+	} else {
+//		ov511_reg_write(dev, 0x16, 0x01);
+		if (ov511->sensor == SEN_OV7610
+		    || ov511->sensor == SEN_OV7620AE) {
+			/* not valid on the OV6620/OV7620/6630? */
+			ov511_i2c_write(dev, 0x0e, 0x04);
+		}
+		ov511_i2c_write_mask(dev, 0x13, autoadjust ? 0x01 : 0x00, 0x21);
+	}
+
+	/* The different sensor ICs handle setting up of window differently */
+	switch (ov511->sensor) {
+	case SEN_OV7610:
+	case SEN_OV7620AE:
+		hwsbase = 0x38;
+		hwebase = 0x3a;
+		vwsbase = vwebase = 0x05;
+		break;
+	case SEN_OV6620:
+	case SEN_OV6630:	// FIXME: Is this right?
+		hwsbase = 0x38;
+		hwebase = 0x3a;
+		vwsbase = 0x05;
+		vwebase = 0x06;
+		break;
+	case SEN_OV7620:
+		hwsbase = 0x2c;
+		hwebase = 0x2d;
+		vwsbase = vwebase = 0x05;
+		break;
+	default:
+		err("Invalid sensor");
+		return -EINVAL;
+	}
+
+	/* Bit 5 of COM C register varies with sensor */ 
+	if (ov511->sensor == SEN_OV6630) {
+		if (width > 176 && height > 144) {  /* CIF */
+			ov511_i2c_write(dev, 0x14, 0x04);
+			hwscale = 1;
+			vwscale = 1;  /* The datasheet says 0; it's wrong */
+			hwsize = 352;
+			vwsize = 288;
+		} else {			    /* QCIF */
+			ov511_i2c_write(dev, 0x14, 0x24);
+			hwsize = 176;
+			vwsize = 144;
+		}
+	}
+	else {
+		if (width > 320 && height > 240) {  /* VGA */
+			ov511_i2c_write(dev, 0x14, 0x04);
+			hwscale = 2;
+			vwscale = 1;
+			hwsize = 640;
+			vwsize = 480;
+		} else {			    /* QVGA */
+			ov511_i2c_write(dev, 0x14, 0x24);
+			hwscale = 1;
+			hwsize = 320;
+			vwsize = 240;
+		}	
+	}
+
+	/* Center the window */
+	hoffset = ((hwsize - width) / 2) >> hwscale;
+	voffset = ((vwsize - height) / 2) >> vwscale;
+
+	/* FIXME! - This needs to be changed to support 160x120 and 6620!!! */
+	if (sub_flag) {
+		ov511_i2c_write(dev, 0x17, hwsbase+(ov511->subx>>hwscale));
+		ov511_i2c_write(dev, 0x18, hwebase+((ov511->subx+ov511->subw)>>hwscale));
+		ov511_i2c_write(dev, 0x19, vwsbase+(ov511->suby>>vwscale));
+		ov511_i2c_write(dev, 0x1a, vwebase+((ov511->suby+ov511->subh)>>vwscale));
+	} else {
+		ov511_i2c_write(dev, 0x17, hwsbase + hoffset);
+		ov511_i2c_write(dev, 0x18, hwebase + hoffset + (hwsize>>hwscale));
+		ov511_i2c_write(dev, 0x19, vwsbase + voffset);
+		ov511_i2c_write(dev, 0x1a, vwebase + voffset + (vwsize>>vwscale));
+	}
+
+	for (i = 0; mlist518[i].width; i++) {
+//		int lncnt, pxcnt;
+		int clock;
+
+		if (width != mlist518[i].width || height != mlist518[i].height)
+			continue;
+
+// FIXME: Subcapture won't be possible until we know what the registers do
+// FIXME: We can't handle anything but YUV420 so far
+
+//		/* Here I'm assuming that snapshot size == image size.
+//		 * I hope that's always true. --claudio
+//		 */
+//		pxcnt = sub_flag ? (ov511->subw >> 3) - 1 : mlist[i].pxcnt;
+//		lncnt = sub_flag ? (ov511->subh >> 3) - 1 : mlist[i].lncnt;
+//
+//		ov511_reg_write(dev, 0x12, pxcnt);
+//		ov511_reg_write(dev, 0x13, lncnt);
+
+		/******** Set the mode ********/		
+
+		/* Mode independent regs */
+		ov511_reg_write(dev, 0x2b, 0x00);
+		ov511_reg_write(dev, 0x2d, 0x00);
+		ov511_reg_write(dev, 0x3b, 0x00);
+		ov511_reg_write(dev, 0x3d, 0x00);
+
+		/* Mode dependent regs. Regs 38 - 3e are always the same as
+		 * regs 28 - 2e */
+		ov511_reg_write_mask(dev, 0x28, mlist518[i].reg28, 0x0f);
+		ov511_reg_write(dev, 0x29, mlist518[i].reg29);
+		ov511_reg_write(dev, 0x2a, mlist518[i].reg2a);
+		ov511_reg_write(dev, 0x2c, mlist518[i].reg2c);
+		ov511_reg_write(dev, 0x2e, mlist518[i].reg2e);
+		ov511_reg_write_mask(dev, 0x38, mlist518[i].reg28, 0x0f);
+		ov511_reg_write(dev, 0x39, mlist518[i].reg29);
+		ov511_reg_write(dev, 0x3a, mlist518[i].reg2a);
+		ov511_reg_write(dev, 0x3c, mlist518[i].reg2c);
+		ov511_reg_write(dev, 0x3e, mlist518[i].reg2e);
+		ov511_reg_write(dev, 0x24, mlist518[i].reg24);
+		ov511_reg_write(dev, 0x25, mlist518[i].reg25);
+
+		/* Windows driver does this here; who knows why */
+		ov511_reg_write(dev, 0x2f, 0x80);
+
+		/******** Set the framerate (to 15 FPS) ********/		
+
+		/* Mode independent, but framerate dependent, regs */
+		/* These are for 15 FPS only */
+		ov511_reg_write(dev, 0x51, 0x08);
+		ov511_reg_write(dev, 0x22, 0x18);
+		ov511_reg_write(dev, 0x23, 0xff);
+		ov511_reg_write(dev, 0x71, 0x19);  /* Compression-related? */
+		/* Bit 5 is what matters here. Of course, it is "reserved" */
+		ov511_i2c_write(dev, 0x54, 0x23);
+
+		ov511_reg_write(dev, 0x2f, 0x80);
+
+		/* Mode dependent regs */
+		if ((width == 352 && height == 288) ||
+		    (width == 320 && height == 240)) {
+			b[0]=0x80; b[1]=0x02; ov518_reg_write_multi(dev, 0x30, b, 2);
+			b[0]=0x90; b[1]=0x01; ov518_reg_write_multi(dev, 0xc4, b, 2);
+			b[0]=0xf4; b[1]=0x01; ov518_reg_write_multi(dev, 0xc6, b, 2);
+			b[0]=0xf4; b[1]=0x01; ov518_reg_write_multi(dev, 0xc7, b, 2);
+			b[0]=0x8e; b[1]=0x00; ov518_reg_write_multi(dev, 0xc8, b, 2);
+			b[0]=0x1a; b[1]=0x00; b[2]=0x02; ov518_reg_write_multi(dev, 0xca, b, 3);
+			b[0]=0x14; b[1]=0x02; ov518_reg_write_multi(dev, 0xcb, b, 2);
+			b[0]=0xd0; b[1]=0x07; ov518_reg_write_multi(dev, 0xcc, b, 2);
+			b[0]=0x20; b[1]=0x00; ov518_reg_write_multi(dev, 0xcd, b, 2);
+			b[0]=0x60; b[1]=0x02; ov518_reg_write_multi(dev, 0xce, b, 2);
+
+		} else if ((width == 176 && height == 144) ||
+			   (width == 160 && height == 120)) {
+			b[0]=0x80; b[1]=0x01; ov518_reg_write_multi(dev, 0x30, b, 2);
+			b[0]=0xc8; b[1]=0x00; ov518_reg_write_multi(dev, 0xc4, b, 2);
+			b[0]=0x40; b[1]=0x01; ov518_reg_write_multi(dev, 0xc6, b, 2);
+			b[0]=0x40; b[1]=0x01; ov518_reg_write_multi(dev, 0xc7, b, 2);
+			b[0]=0x60; b[1]=0x00; ov518_reg_write_multi(dev, 0xc8, b, 2);
+			b[0]=0x0f; b[1]=0x33; b[2]=0x01; ov518_reg_write_multi(dev, 0xca, b, 3);
+			b[0]=0x40; b[1]=0x01; ov518_reg_write_multi(dev, 0xcb, b, 2);
+			b[0]=0xec; b[1]=0x04; ov518_reg_write_multi(dev, 0xcc, b, 2);
+			b[0]=0x13; b[1]=0x00; ov518_reg_write_multi(dev, 0xcd, b, 2);
+			b[0]=0x6d; b[1]=0x01; ov518_reg_write_multi(dev, 0xce, b, 2);
+		} else {
+			/* Can't happen, since we already handled this case */
+			err("ov518_mode_init_regs(): **** logic error ****");
+		}
+
+		ov511_reg_write(dev, 0x2f, 0x80);
+
+		/* The OV6620 needs special handling. This prevents the 
+		 * severe banding that normally occurs */
+		if (ov511->sensor == SEN_OV6620)
+		{
+			/* Clock down */
+			ov511_i2c_write(dev, 0x2a, 0x04);
+			ov511_i2c_write(dev, 0x11, 0x03);
+			ov511_i2c_write(dev, 0x2a, 0x84);
+			/* This next setting is critical. It seems to improve
+			 * the gain or the contrast. The "reserved" bits seem
+			 * to have some effect in this case. */
+			ov511_i2c_write(dev, 0x2d, 0x85);
+
+		}
+		else
+		{
+			/* Calculate and set the clock divisor */
+// Color is always on
+//			clock = ((sub_flag ? ov511->subw * ov511->subh : width * height)
+//			* (mlist518[i].color ? 3 : 2) / 2) / 66000;
+			clock = ((sub_flag ? ov511->subw * ov511->subh : width * height)
+			* (3 / 2)) / 66000;
+#if 0
+			clock *= cams;
+#endif
+			ov511_i2c_write(dev, 0x11, clock);
+		}
+
+		/* We only have code to convert GBR -> RGB24 */
+		if ((mode == VIDEO_PALETTE_RGB24) && sensor_gbr)
+			ov511_i2c_write(dev, 0x12, 0x04 | (testpat?0x0a:0x08));
+		else
+			ov511_i2c_write(dev, 0x12, 0x04 | (testpat?0x02:0x00));
+
+		/* Enable/Disable AGC */
+		if (ov511_i2c_write_mask(dev, 0x12, autoadjust ? 0x20 : 0x00, 0x20) < 0)
+			return -1;
+
+		/* 7620/6620/6630? don't have register 0x35, so play it safe */
+		if (ov511->sensor == SEN_OV7610 ||
+		    ov511->sensor == SEN_OV7620AE)
+			ov511_i2c_write(dev, 0x35, 0x1e);
+
+		break;
+	}
+
+	if (lightfreq)
+		if (ov51x_set_light_freq(ov511, lightfreq))
+			return -1;
+
+	if (ov51x_set_banding_filter(ov511, bandingfilter))
+			return -1;
+
+	if (compress) {
+//		ov511_reg_write(dev, 0x78, 0x03); // Turn on Y compression
+//		ov511_reg_write(dev, 0x79, 0x00); // Disable LUTs
+	}
+
+	if (ov511_restart(ov511) < 0)
+		return -EIO;
+
+	if (mlist518[i].width == 0) {
+		err("Unknown mode (%d, %d): %d", width, height, mode);
+		return -EINVAL;
+	}
+
+#ifdef OV511_DEBUG
+	if (dump_sensor)
+		ov511_dump_i2c_regs(dev);
+#endif
+
+	return 0;
+}
+
+/* This is a wrapper around the OV511, OV518, and sensor specific functions */
+static int
+mode_init_regs(struct usb_ov511 *ov511,
+	       int width, int height, int mode, int sub_flag)
+{
+	if (ov511->bridge == BRG_OV518PLUS)
+		return ov518_mode_init_regs(ov511, width, height, mode, sub_flag);
+	else
+		return ov511_mode_init_regs(ov511, width, height, mode, sub_flag);
+}
+
+/* This sets the default image parameters (Size = max, RGB24). This is
+ * useful for apps that use read() and do not set these.
+ */
+static int ov51x_set_default_params(struct usb_ov511 *ov511)
+{
+	int i;
+
+	/* Set default sizes in case IOCTL (VIDIOCMCAPTURE) is not used
+	 * (using read() instead). */
+	for (i = 0; i < OV511_NUMFRAMES; i++) {
+		ov511->frame[i].width = ov511->maxwidth;
+		ov511->frame[i].height = ov511->maxheight;
+		ov511->frame[i].depth = 24;
+		ov511->frame[i].bytes_read = 0;
+		ov511->frame[i].segment = 0;
+		ov511->frame[i].format = VIDEO_PALETTE_RGB24;
+		ov511->frame[i].segsize = GET_SEGSIZE(ov511->frame[i].format);
+	}
+
+	/* Initialize to max width/height, RGB24 */
+	if (mode_init_regs(ov511, ov511->maxwidth, ov511->maxheight,
+			   VIDEO_PALETTE_RGB24, 0) < 0)
+		return -EINVAL;
+
+	return 0;
+}
+
+/**********************************************************************
+ *
+ * Color correction functions
+ *
+ **********************************************************************/
+
+/*
+ * Turn a YUV4:2:0 block into an RGB block
+ *
+ * Video4Linux seems to use the blue, green, red channel
+ * order convention-- rgb[0] is blue, rgb[1] is green, rgb[2] is red.
+ *
+ * Color space conversion coefficients taken from the excellent
+ * http://www.inforamp.net/~poynton/ColorFAQ.html
+ * In his terminology, this is a CCIR 601.1 YCbCr -> RGB.
+ * Y values are given for all 4 pixels, but the U (Pb)
+ * and V (Pr) are assumed constant over the 2x2 block.
+ *
+ * To avoid floating point arithmetic, the color conversion
+ * coefficients are scaled into 16.16 fixed-point integers.
  * They were determined as follows:
  *
  *	double brightness = 1.0;  (0->black; 1->full scale) 
@@ -1373,7 +2296,8 @@
 }
 
 static void
-ov511_dumppix(unsigned char *pIn0, unsigned char *pOut0,
+ov511_dumppix(struct ov511_frame *frame, 
+	      unsigned char *pIn0, unsigned char *pOut0,
 	      int iOutY, int iOutUV, int iHalf, int iWidth)
 {
 	int i, j, k;
@@ -1410,12 +2334,22 @@
 		break;
 	case 3: /* This will dump only the Y channel data stream as-is */
 		pIn = pIn0 + 128;
-		pOut = pOut0 + output_offset;
+		pOut = pOut0 + frame->output_offset;
 		for (i = 0; i < 256; i++) {
 			*pOut++ = *pIn;
 			*pOut++ = *pIn;
 			*pOut++ = *pIn++;
-			output_offset += 3;
+			frame->output_offset += 3;
+		}
+		break;
+	case 4: /* This will dump the whole unformatted data stream as-is */
+		pIn = pIn0;
+		pOut = pOut0 + frame->output_offset;
+		for (i = 0; i < 384; i++) {
+			*pOut++ = *pIn;
+			*pOut++ = *pIn;
+			*pOut++ = *pIn++;
+			frame->output_offset += 3;
 		}
 		break;
 	} /* End switch (dumppix) */
